//+------------------------------------------------------------------+
//|                                       Proffessor_ver7.1_2011.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                   Modify TarasBY |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern int    Magic           = 2222;
extern double lot             = 0.02;
extern int    znak            = 4;      // 5,   
extern int    MAX_Lines       = 10;     //       
extern double pluslot         = 0.01;   //      
extern double p_Delta1        = 80;     //      
extern int    p_Delta         = 60;     //     
extern int    TP              = 25;     //      
extern int    tral            = 10;     //      
extern int    step            = 1;      //   
extern int    Profit          = 10;     //     
extern double f               = 40;     //    ADX
extern double bar             = 2;      //   ADX
extern double st              = 25;     // /
extern double st_r            = 20;     //   ,    
extern int    timeframe       = 1;      //   ADX 0-,1-1, 2-5, 3-15, 4-30, 5-1
                                        //6-4, 7-, 8-, 9-
extern int    StartHour       = 0;      //   
extern int    EndHour         = 24;     //   
extern bool   Fr_Stop         = true;   // true,      
extern int    pop             = 3;      //   
extern int    Net_Auto        = 0;      // 1,    
extern int    days            = 10;     //   
extern double koeff           = 2;      //    
extern double k_delta         = 1.7;    //    
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gd_BaseLots, gd_AntiLots, gd_plusAntiLots,
              iflet, ibuy, isell, stoh, stoh_sign, pipsPrice, pipsPrices;
int           x, q, own_s, own_b, trals, gi_MyOrders,
              gi_TF_ADX, Delta1, Delta, k, ks, pipsZero, pipsZeros;
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
#include <WinUser32.mqh>
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
    Comment ("ProfessorSoft_v7.1_2011");
    int lia_Periods[] = {0,1,5,15,30,60,240,1440,10080,43200};
    if (timeframe >= 0 && timeframe <= 8) gi_TF_ADX = lia_Periods[timeframe];
    else gi_TF_ADX = 0;
    if (Net_Auto == 0)
    {
        Delta1 = p_Delta1;
        Delta = p_Delta;
    }
    if (pluslot < 0.02) gd_plusAntiLots = 0.01; else gd_plusAntiLots = NormalizeDouble (pluslot / 2, 2);
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
    Comment ("");
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
//----
    if (Net_Auto != 0)
    {
        double sr_day = 0;
        for (int q = days; q > 0; q--)
        {
            sr_day = sr_day + (iHigh (Symbol(), PERIOD_D1, q) - iLow (Symbol(), PERIOD_D1, q)) * 10000; 
//          Alert (sr_day);
        }
        Delta1 = NormalizeDouble ((sr_day / days) / koeff, 0);
        Delta = NormalizeDouble (Delta1 / k_delta, 0);
    }
    gi_MyOrders = fMyPositions (Magic);
    iflet = iADX (NULL, gi_TF_ADX, 14, PRICE_CLOSE,MODE_MAIN, bar);
    ibuy = iADX (NULL, gi_TF_ADX, 14, PRICE_CLOSE, MODE_PLUSDI, bar); 
    isell = iADX (NULL, gi_TF_ADX, 14, PRICE_CLOSE, MODE_MINUSDI, bar); 
    stoh = iStochastic (NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, 0);
    stoh_sign = iStochastic (NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, 0);
    if (gi_MyOrders == 0 && time())
    {
        if (Fr_Stop) if (DayOfWeek() == 5) return (0);
        if (iflet < f) //     
        {
            if (ibuy > isell && stoh > stoh_sign)
            {
                gd_BaseLots = lot;
                OrderSend (Symbol(), OP_BUY, gd_BaseLots, Ask, 3, 0, NormalizeDouble (Bid + TP * Point, Digits), "", Magic, 0, Blue);
                if (lot < 0.02) gd_AntiLots = 0.01; else gd_AntiLots = NormalizeDouble (lot / 2, 2);
                OrderSend (Symbol(), OP_SELL, gd_AntiLots, Bid, 3, 0, NormalizeDouble (Ask - TP * Point, Digits), "", Magic, 0, Red);
                for (x = 0; x < MAX_Lines; x++)
                {
                    gd_BaseLots += pluslot;
                    OrderSend (Symbol(), OP_BUYLIMIT, gd_BaseLots, NormalizeDouble (Ask - (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Blue);
                    gd_AntiLots += gd_plusAntiLots;
                    OrderSend (Symbol(), OP_SELLLIMIT, gd_AntiLots, NormalizeDouble (Bid + (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Red);     
                }
            }
            else if (ibuy < isell && stoh < stoh_sign)//     
            {
                gd_BaseLots = lot;
                OrderSend (Symbol(), OP_BUY, gd_AntiLots, Ask, 3, 0, NormalizeDouble (Bid + TP * Point, Digits), "", Magic, 0, Blue);
                if (lot < 0.02) gd_AntiLots = 0.01; else gd_AntiLots = NormalizeDouble (lot / 2, 2);
                OrderSend (Symbol(), OP_SELL, gd_BaseLots, Bid, 3, 0, NormalizeDouble (Ask - TP * Point, Digits), "", Magic, 0, Red);
                for (x = 0; x < MAX_Lines; x++)
                {
                    gd_BaseLots += pluslot;
                    OrderSend (Symbol(), OP_BUYLIMIT, gd_AntiLots, NormalizeDouble (Ask - (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Blue);
                    gd_AntiLots += gd_plusAntiLots;
                    OrderSend (Symbol(), OP_SELLLIMIT, gd_BaseLots, NormalizeDouble (Bid + (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Red);     
                }
            }
            else return (0);
        }
        else return(0);
    }  
    else if (gi_MyOrders > 0)
    {
        Comment ("          Balance  ", AccountBalance(), "          Profit_BUY  ", Profit_buy(),
        "     Profit_SELL  ", Profit_sell(), "\n          Equity  ", AccountEquity(), "\n          Profit  ", OrdersProfit());
        own_b = 0;
        own_s = 0;
        for (int i = OrdersTotal() - 1; i >= 0; i--)
        {
            OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
            if (OrderMagicNumber() != Magic) continue;
            if (OrderType() == OP_BUY) own_b += 1;
            if (OrderType() == OP_SELL) own_s += 1;
        }
        if (own_b == 0)
        {
            if (own_s == 0)
            {
                del_BUYLIM();
                setBUY();
                del_SELLLIM();
                setSELL();
            }
            else if (own_s == 1)
            {
                del_BUYLIM();
                setBUY();
                TralSELL();
            }
            else if (own_s > 1)
            {
                del_BUYLIM();
                setBUY();
                ModifSELLs();
            }
        }
        else if (own_b == 1)
        {
            if (own_s == 0)
            {
                TralBUY();
                del_SELLLIM();
                setSELL();
            }
            else if (own_s == 1)
            {
                TralBUY();
                TralSELL();
            }
            else if (own_s > 1)
            {
                TralBUY();
                ModifSELLs();
            }
        }
        else if (own_b > 1)
        {
            if (own_s == 0)
            {
                ModifBUYs();
                del_SELLLIM();
                setSELL();
            }
            else if (own_s == 1)
            {
                ModifBUYs();
                TralSELL();
            }
            else if (own_s > 1)
            {
               ModifBUYs();
               ModifSELLs();
            }
        }
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void del_BUYLIM()
{
    bool closed;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {          
        OrderSelect (i, SELECT_BY_POS, MODE_TRADES);       
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() != OP_BUYLIMIT) continue;
        for (q = 0; q < pop; q++)
        {
             closed = false;
             closed = OrderDelete (OrderTicket());
             if (closed) return;
        }
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void del_SELLLIM()
{
    bool closed;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {          
        OrderSelect (i, SELECT_BY_POS, MODE_TRADES);       
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() != OP_SELLLIMIT) continue;
        for (q = 0; q < pop; q++)
        {
             closed = false;
             closed = OrderDelete (OrderTicket());
             if (closed) return;
        }
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void setBUY()
{
    if (Fr_Stop) if (DayOfWeek() == 5 || !time()) return;
    if (ibuy > isell) //     
    {
        gd_BaseLots = lot;
        OrderSend (Symbol(), OP_BUY, gd_BaseLots, Ask, 3, 0, NormalizeDouble (Bid + TP * Point, Digits), "", Magic, 0, Blue);
        for (x = 0; x < MAX_Lines; x++)
        {
            gd_BaseLots += pluslot;
            OrderSend (Symbol(), OP_BUYLIMIT, gd_BaseLots, NormalizeDouble (Ask - (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Blue);
        }
    }
    else if (ibuy < isell) //     
    {
        if (lot < 0.02) gd_AntiLots = 0.01; else gd_AntiLots = NormalizeDouble (lot / 2, 2);
        OrderSend (Symbol(), OP_BUY, gd_AntiLots, Ask, 3, 0, NormalizeDouble (Bid + TP * Point, Digits), "", Magic, 0, Blue);
        for (x = 0; x < MAX_Lines; x++)
        {
            gd_AntiLots += gd_plusAntiLots;
            OrderSend (Symbol(), OP_BUYLIMIT, gd_AntiLots, NormalizeDouble (Ask - (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Blue);
        }
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void setSELL()
{
    if (Fr_Stop) if (DayOfWeek() == 5 || !time()) return;
    if (ibuy > isell)//     
    {
        if (lot < 0.02) gd_AntiLots = 0.01; else gd_AntiLots = NormalizeDouble (lot / 2, 2);
        OrderSend (Symbol(), OP_SELL, gd_AntiLots, Bid, 3, 0, NormalizeDouble (Ask - TP * Point, Digits), "", Magic, 0, Red);
        for (x = 0; x < MAX_Lines; x++)
        {
            gd_AntiLots += gd_plusAntiLots;
            OrderSend (Symbol(), OP_SELLLIMIT, gd_AntiLots, NormalizeDouble (Bid + (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Red);     
        }
    }
    else if (ibuy < isell)//     
    {
        gd_BaseLots = lot;
        OrderSend (Symbol(), OP_SELL, gd_BaseLots, Bid, 3, 0, NormalizeDouble (Ask - TP * Point, Digits), "", Magic, 0, Red);
        for (x = 0; x < MAX_Lines; x++)
        {
            gd_BaseLots += pluslot;
            OrderSend (Symbol(), OP_SELLLIMIT, gd_BaseLots, NormalizeDouble (Bid + (Delta1 + x * Delta) * Point, Digits), 3, 0, 0, "", Magic, 0, Red);     
        }
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void TralBUY()
{
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_BUY) if (Profit_buy() > 0) TrailPositions (OrderTicket());    
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void TralSELL()
{
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_SELL) if (Profit_sell() > 0) TrailPositions (OrderTicket());    
    }  
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void ModifBUYs()
{
    k = 0;
    pipsZero = 0;
    pipsPrice = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_BUY) k = k + OrderLots() / 0.01;
    }
    pipsPrice = k * 0.01 / 0.1;//  
    if (znak == 5) {pipsZero = 10 * (-NormalizeDouble (Profit_buy() / pipsPrice, 0));}
    else {pipsZero = (-NormalizeDouble (Profit_buy() / pipsPrice, 0));}
    //Print ("  :   buy=",pipsPrice,"   sell=",pipsPrices,"   buy=",pipsZero,"   sell=",pipsZeros);
    for (i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_BUY)
        OrderModify (OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble (Bid + pipsZero * Point + Profit * Point, Digits), 0, Blue); 
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void ModifSELLs()
{
    ks = 0;
    pipsZeros = 0;
    pipsPrices = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_SELL) ks = ks + OrderLots() / 0.01;
    }
    pipsPrices = ks * 0.01 / 0.1;//  
    if (znak == 5) {pipsZeros = 10 * (-NormalizeDouble (Profit_sell() / pipsPrices, 0));}
    else {pipsZeros = (-NormalizeDouble (Profit_sell() / pipsPrices, 0));}
    // Print ("  :   buy=",pipsPrice,"   sell=",pipsPrices,"   buy=",pipsZero,"   sell=",pipsZeros);
    for (i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_SELL)
        OrderModify (OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble (Ask - pipsZeros * Point - Profit * Point, Digits), 0, Red);  
    }
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool time()
{
    if (StartHour < EndHour) 
    {if (Hour() >= StartHour && Hour() <EndHour) return (true); else return (false);}
    if (StartHour > EndHour) 
    {if (Hour() >= EndHour && Hour() < StartHour) return (false); else return (true);}
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double OrdersProfit()
{
    double rezultSymb = 0;
    string SMB = Symbol();
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol()!= SMB) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() > 1) continue;
        rezultSymb += OrderProfit();
    }
    return (rezultSymb);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double Profit_buy()
{
    double rezultSymb=0;
    string SMB=Symbol();
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol()!= SMB) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_BUY) {rezultSymb += OrderProfit();} 
    }
    return (rezultSymb);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double Profit_sell()
{
    double rezultSymb = 0;
    string SMB = Symbol();
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol()!= SMB) continue;
        if (OrderMagicNumber() != Magic) continue;
        if (OrderType() == OP_SELL) {rezultSymb += OrderProfit();} 
    }
    return (rezultSymb);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void TrailPositions (int i) //   
{
    if (!OrderSelect (i, SELECT_BY_TICKET, MODE_TRADES)) return;
    if (OrderType() == OP_BUY )  
    {
        if (Bid - OrderOpenPrice() > tral * Point) 
        {
            if (OrderStopLoss() < Bid - (tral + step - 1) * Point)
            {OrderModify (OrderTicket(), OrderOpenPrice(), NormalizeDouble (Bid - tral * Point, Digits), OrderTakeProfit(), 0, Blue);}
        }   
    }
    if (OrderType() == OP_SELL)  
    {
        if (OrderOpenPrice() - Ask > tral * Point) 
        {
            if (OrderStopLoss() > Ask + (tral + step - 1) * Point || OrderStopLoss() == 0)
            {OrderModify (OrderTicket(), OrderOpenPrice(), NormalizeDouble (Ask + tral * Point, Digits), OrderTakeProfit(), 0, Red);}
        }  
    }   
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (int fi_Magic = -1)     // Magic
{
    int li_total = OrdersTotal(), li_ord = 0;
//----
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != fi_Magic) {if (fi_Magic >= 0) continue;}
        li_ord++;
    }
//----
    return (li_ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

